SuperCupSeeSawEvent = {}
local SuperCupSeeSawEvent_mt = Class(SuperCupSeeSawEvent, Event)

InitEventClass(SuperCupSeeSawEvent, "SuperCupSeeSawEvent")

function SuperCupSeeSawEvent:emptyNew()
    local self = Event:new(SuperCupSeeSawEvent_mt)
    return self
end

function SuperCupSeeSawEvent:new(object, isActive, isForced)
    local self = SuperCupSeeSawEvent:emptyNew()
    self.object = object
    self.isActive = isActive
    self.isForced = isForced or false

    return self
end

function SuperCupSeeSawEvent:readStream(streamId, connection)
    self.object = NetworkUtil.readNodeObject(streamId)
    self.isActive = streamReadBool(streamId)
    self.isForced = streamReadBool(streamId)

    self:run(connection)
end

function SuperCupSeeSawEvent:writeStream(streamId, connection)
    NetworkUtil.writeNodeObject(streamId, self.object)
    streamWriteBool(streamId, self.isActive)
    streamWriteBool(streamId, self.isForced)
end

function SuperCupSeeSawEvent:run(connection)
    self.object:setBeaconLightVisibility(self.isActive, self.isForced, true)

    -- Send from server to all clients
    if not connection:getIsServer() then
        g_server:broadcastEvent(self, false, connection, self.object)
    end
end

function SuperCupSeeSawEvent.sendEvent(object, isActive, isForced, noEventSend)
    if not noEventSend then
        if g_server ~= nil then
            g_server:broadcastEvent(SuperCupSeeSawEvent:new(object, isActive, isForced), nil, nil, object)
        else
            g_client:getServerConnection():sendEvent(SuperCupSeeSawEvent:new(object, isActive, isForced))
        end
    end
end
